require 'play'

function love.load()
	composer = love.thread.newThread('composer', 'compose.lua')
	main = love.thread.getThread()
	composer:start()
	composer:set('needsound', true)
	waiting = true
	currsound = nil
	queue = {}
	softnotes = true
	damp = false
end

function refresh()
	queue = {} -- clear queue to speed up results
	composer:set('needsound', true)
end

function love.update(dt)
	if main:peek('sound') then
		queue[#queue+1] = main:get('sound')
		if #queue < 3 then --try to keep 3 fragments in the queue
			composer:set('needsound', true)
		end
	end
	if composer:peek('error') then
		print(composer:get('error'))
	end
	if (not currsound or currsound:isStopped()) and #queue > 0 then
		currsound = table.remove(queue, 1)
		currsound:play()
		composer:set('needsound', true)
	end
end

function love.keypressed(key)
	if key == ' ' then
		softnotes = not softnotes
		composer:set('softnotes', softnotes)
		refresh()
	elseif key == 'd' then
		damp = not damp
		composer:set('damp', damp)
		refresh()
	elseif key == 'escape' then
		love.event.push 'quit'
	end
end
