function p2Hz(p)
	return 440 * 2^((p - 69) / 12)
end
tones = {}
for i=1, 150 do
	tones[i] = p2Hz(i)
end

play = {}

local max = math.max
local sin = math.sin
local SAMP = 44100
local invSAMP = 1/SAMP
local c = 2*math.pi
local function normal(t, len, freq)
	return sin(c * t * freq)
end 
local function id(v) return v end
-- seq is a sequence of {offset, length, tone, amplitude} tuples
-- play.create destroys seq
function play.create(seq, instr, volctrl)
	instr = instr or normal
	volctrl = volctrl or id
	
	local slen = 0
	local maxamp = 0
	for i,tup in ipairs(seq) do
		slen = max(slen, tup[1] + tup[2])
		maxamp = max(maxamp, tup[4])
		tup[3] = tones[tup[3]]
	end
	--for i,tup in ipairs(seq) do
	--	tup[4] = tup[4] / maxamp
	--end
	local snd = love.sound.newSoundData(SAMP*slen, SAMP, 16, 1)
	for i=0, SAMP*slen - 1 do
		local s = 0
		local t = i*invSAMP
		for _,tup in ipairs(seq) do
			local offset = t - tup[1]
			local len = tup[2]
			if offset > len then
				table.remove(seq, _)
			elseif offset > 0 then
				s = s + volctrl(tup[4], offset, len)*instr(offset, len, tup[3])
			end
		end
		snd:setSample(i, s)
	end
	return snd
end
